/*-
 * ~~~~~~licensing~~~~~~
 * object-runtime-core
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.objects.runtime.impl;

import ru.entaxy.esb.resources.EntaxyResource;
import ru.entaxy.esb.resources.EntaxyResource.RESOURCE_SCOPE;
import ru.entaxy.platform.base.support.CommonUtils;
import ru.entaxy.platform.objects.runtime.EntaxyRuntimeObjectResource;

public class EntaxyRuntimeObjectResourceImpl implements EntaxyRuntimeObjectResource {

	public static EntaxyRuntimeObjectResourceImpl create(String resourceDescriptor) throws IllegalArgumentException {
		
		if (!CommonUtils.isValid(resourceDescriptor))
			throw new IllegalArgumentException("Resource descriptor is empty");
		String[] data = resourceDescriptor.split(";");
		EntaxyRuntimeObjectResourceImpl resourceImpl = new EntaxyRuntimeObjectResourceImpl(data[0]);
		if (data.length > 1)
			try {
				RESOURCE_SCOPE scope = RESOURCE_SCOPE.valueOf(data[1].trim().toUpperCase());
				resourceImpl.setScope(scope);
			} catch (Exception e) {
				// use default scope
			}
		return resourceImpl;
	}
	
	protected RESOURCE_SCOPE scope = RESOURCE_SCOPE.RUNTIME;
	protected String url;
	
	public EntaxyRuntimeObjectResourceImpl(String url) {
		super();
		this.url = url;
	}
	
	@Override
	public RESOURCE_SCOPE getScope() {
		return scope;
	}

	@Override
	public EntaxyResource getResource() {
		return EntaxyRuntimeObjectServiceImpl.getInstance()
				.getResourceService().getResource(url);
	}

	@Override
	public String getResourceUrl() {
		return url;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public void setScope(RESOURCE_SCOPE scope) {
		this.scope = scope;
	}

	
}
